/*
 * Copyright 2007 The Fornax Project Team, including the original
 * author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.sculptor.template.domain

import static extension org.sculptor.ext.Helper.*;
import sculptormetamodel.DomainObject
import sculptormetamodel.BasicType
import sculptormetamodel.Attribute
import sculptormetamodel.Reference

class DomainObjectProperties {
	def domainObjectProperties (DomainObject domObj) {
		var it = domObj;
		println('''
			javaHeader()
			package getDomainPackage();
			
			/**
			 * This generated interface defines property names for all
			 * attributes and associatations in
			 * {@link getDomainPackage().name}.
			 * <p>
			 * These properties are useful when building
			 * criteria with {@link fw("accessapi.ConditionalCriteriaBuilder")},
			 * which can be used with findByCondition Repository operation.
			 */
			/*
			public class nameProperties {
				private nameProperties() {
				}
			
				REMnote that static methods are not generated in BasicType, since they can't be root of the criteriaENDREM
				IF metaType != typeof(BasicType)
					sharedInstance()
					it.allAttributes.forEach[staticLeafProperty(it)]
					getAllReferences().filter(e | e.isEnumReference() || (nosql() && e.isUnownedReference())).forEach[staticLeafProperty(it)]
					getAllReferences().filter(e | e.isEnumReference() || (nosql() && e.isUnownedReference())).forEach[staticReferenceProperty(it)]
				ENDIF
			
				domainObjectProperty
				domainObjectPropertiesImpl
			}
		''')
	}

	// Rest methods are dummy for now
	def sharedInstance() {
		"\n>>> sharedInstance()"
	}

	def staticLeafProperty(Attribute attr) {
		"\n>>> staticLeafProperty(Attribute attr)"
	}

	def staticLeafProperty(Reference ref) {
		"\n>>> staticLeafProperty(Reference ref)"
	}

	def staticReferenceProperty(Reference ref) {
		"\n>>> staticReferenceProperty(Reference ref)"
	}

	def domainObjectPropertiesImpl() {
		"\n>>> domainObjectPropertiesImpl()"
	}

	def domainObjectProperty() {
		"\n>>>domainObjectProperty()"
	}
}
